=== debian/changelog ===
boost1.88 (1.88.0~beta1-1ubuntu1) plucky; urgency=medium

  * Merge with Debian; remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2

 -- Matthias Klose <doko@ubuntu.com>  Thu, 10 Apr 2025 12:07:40 +0200

boost1.88 (1.88.0~beta1-1) unstable; urgency=medium

  * [df53d4e] Disable boost.stacktrace.from_exception on some archs.
              (Closes: #1102107)
  * Upload into unstable.

 -- Anton Gladky <gladk@debian.org>  Sun, 06 Apr 2025 15:27:52 +0200

boost1.88 (1.88.0~beta1-1~exp1ubuntu1) plucky; urgency=medium

  * Merge with Debian; remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2

 -- Matthias Klose <doko@ubuntu.com>  Fri, 04 Apr 2025 10:50:59 +0200

boost1.88 (1.88.0~beta1-1~exp1) experimental; urgency=medium

  * [9291fb5] Update patches for 1.88
  * [9738360] Update d/copyright
  * [1a78c7b] Update d/control, d/rules for new version

 -- Anton Gladky <gladk@debian.org>  Wed, 02 Apr 2025 20:07:45 +0200

boost1.83 (1.83.0-4.2ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2

 -- Matthias Klose <doko@ubuntu.com>  Tue, 25 Mar 2025 14:26:18 +0100

boost1.83 (1.83.0-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Another fix for numpy 2.0. Closes: #1099671.
    - Compare pointers directly instead of using PyArray_EquivTypes
  * Enable context library on ppc64. Closes: #1071542.
  * Use static const for next/prior from C++17. Closes: #1093824.

 -- Matthias Klose <doko@debian.org>  Tue, 25 Mar 2025 14:04:56 +0100

boost1.83 (1.83.0-4.1ubuntu2) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 16:55:46 +0000

boost1.83 (1.83.0-4.1ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Feb 2025 17:07:26 +0100

boost1.83 (1.83.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with NumPy 2.x. Closes: #1094654.

 -- Matthias Klose <doko@debian.org>  Fri, 14 Feb 2025 16:45:31 +0100

boost1.83 (1.83.0-4ubuntu2) plucky; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 05 Jan 2025 20:29:18 +0100

boost1.83 (1.83.0-4ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 09 Dec 2024 18:46:02 +0100

boost1.83 (1.83.0-4) unstable; urgency=medium

  [ Samuel Thibault ]
  * control: Add hurd-amd64 for context, coroutine, fiber packages.
  * [a2dab5e] control: Add hurd-amd64 for context, coroutine, fiber packages.

  [ Heinrich Schuchardt ]
  * [62a479e] Fix autopkgtests fail on armhf. (Closes: #1079106)

  [ Anton Gladky ]
  * [49b0d7f] Update the minimal cmake version for autopkgtest to 3.18.
              (Closes: #1087853)

 -- Anton Gladky <gladk@debian.org>  Sat, 07 Dec 2024 20:39:34 +0100

boost1.83 (1.83.0-3.2ubuntu4) plucky; urgency=medium

  * No-change rebuild for openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 30 Nov 2024 07:13:58 +0100

boost1.83 (1.83.0-3.2ubuntu3) plucky; urgency=medium

  * No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Nov 2024 10:53:57 +0100

boost1.83 (1.83.0-3.2ubuntu2) oracular; urgency=medium

  [ Heinrich Schuchardt ]
  * Disable OpenMPI related tests on armhf (LP: #2076225)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 04 Sep 2024 00:10:13 +0200

boost1.83 (1.83.0-3.2ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 03 Sep 2024 20:15:17 +0200

boost1.83 (1.83.0-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Additional workaround for broken architecture detection under x32
    (Closes: #1079358)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 22 Aug 2024 14:09:24 +0200

boost1.83 (1.83.0-3.1ubuntu2) oracular; urgency=medium

  * Disable OpenMPI related tests on armhf (LP: #2076225)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Mon, 12 Aug 2024 09:57:42 +0200

boost1.83 (1.83.0-3.1ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 01 Aug 2024 13:09:23 +0200

boost1.83 (1.83.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "Boost.Signals2 causes FTBFS", cherry-picking upstream patch
   (Closes: #1056100)
  * Fix "autopkgtest regression with CMake 3.30+", enforcing the new CMP0167
    policy. (Closes: #1076426)

 -- Tobias Frost <tobi@debian.org>  Tue, 30 Jul 2024 09:09:13 +0200

boost1.83 (1.83.0-3ubuntu2) oracular; urgency=medium

  * Apply distro CXXFLAGS when boostrapping b2 (LP: #2073861)

 -- Simon Chopin <schopin@ubuntu.com>  Tue, 23 Jul 2024 11:08:40 +0200

boost1.83 (1.83.0-3ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 29 May 2024 08:02:39 +0200

boost1.83 (1.83.0-3) unstable; urgency=medium

  * [4b317f3] Add upstream fix for dogecoin. (Closes: #1059133)

 -- Anton Gladky <gladk@debian.org>  Mon, 27 May 2024 06:59:36 +0200

boost1.83 (1.83.0-2.1ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:23:37 +0000


